---
title: "Orekit 12.2 released"
excerpt: "Version 12.2 is a minor release of Orekit."
layout: post_orekit
publication_year: 2024
date: 2024-10-18 13:00:00 +0200
modified: 2024-10-18 13:00:00 +0200
project: orekit
categories:
- News
tags:
- news
- release
---

The Orekit team is pleased to announce the release of Orekit version 12.2.

This is a minor release of Orekit, including new features and bug fixes.
Main changes are:
* Introduction of indirect optimal control
    * Adjoint equations as defined by Pontryagin's Maximum Principle with Cartesian coordinates for a range of forces: (gravitational, inertial) including J2
    * So-called energy cost functions (proportional to the integral of the control vector's squared norm), with Hamitonian evaluation
    * Single shooting based on Newton algorithm for the case of fixed time, fixed Cartesian bounds
* Attitude
    * Implementation of attitude provider with primary target and secondary constraint
* Data parsing
    * Implementation of a parser for GRGM1200B-like gravity models
* Noticeable bug fixes
    * Use proper body-fixed (ITRF) frame in DSST zonal (see [Issue 1104](https://gitlab.orekit.org/orekit/orekit/-/issues/1104))
    * A long standing bug on the Brouwer-Lyddane model has been fixed (see [Issue 947](https://gitlab.orekit.org/orekit/orekit/-/issues/947))
* Miscelleneous
    * Impulsive maneuvers can now be added to relevant `PropagatorBuilder`
    * `PropagatorBuilder` are now cloneable
    * Closing gap in implemented methods between classes and their field equivalent
    * Implementation of several quality of life methods
    * Several bug fixes

This version depends on Hipparchus 3.1.

For complete release notes please see:
https://www.orekit.org/site-orekit-12.2/changes-report.html

The maven artifacts are available in maven central.
The source and binaries can be retrieved from the forge releases page:
https://gitlab.orekit.org/orekit/orekit/-/releases
